# Coveo Matrix Component (CoveoMatrix)

## Index

### Methods

- debugInfo
- disable
- enable
- getBindings
- getCellElement
- getCellValue
- getSelectedColumnValue
- getSelectedRowValue
- selectCell
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- data
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- selectedColumnValue
- selectedRowValue
- ID

### Accessors

- usageAnalytics

### Component Options

- cellFontSize
- columnField
- columnFieldValues
- columnHeader
- columnLabels
- computedField
- computedFieldFormat
- computedFieldOperation
- enableColumnTotals
- enableHoverPreview
- enableRowTotals
- maximumNumberOfRows
- maximumNumberOfValuesInGroupBy
- previewDelay
- previewMaxWidth
- previewMinWidth
- previewSortCriteria
- previewSortField
- previewTemplate
- rowField
- sortCriteria
- title

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  #### Returns IComponentBindings

### getCellElement

- getCellElement(rowNumber: number, columnNumber: number): HTMLElement

- - Defined in ui/Matrix/Matrix.ts :408

  #### Parameters

  - ##### rowNumber: number

  - ##### columnNumber: number

  #### Returns HTMLElement

  The associated HTMLElement.

### getCellValue

- getCellValue(rowNumber: number, columnNumber: number): string

- - Defined in ui/Matrix/Matrix.ts :418

  #### Parameters

  - ##### rowNumber: number

  - ##### columnNumber: number

  #### Returns string

  The associated string.

### getSelectedColumnValue

- getSelectedColumnValue(): string

- - Defined in ui/Matrix/Matrix.ts :391

  #### Returns string

### getSelectedRowValue

- getSelectedRowValue(): string

- - Defined in ui/Matrix/Matrix.ts :398

  #### Returns string

### selectCell

- selectCell(rowNumber: number, columnNumber: number): void

- - Defined in ui/Matrix/Matrix.ts :363

  #### Parameters

  - ##### rowNumber: number

  - ##### columnNumber: number

  #### Returns void

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  #### Parameters

  - ##### element: HTMLElement

  - ##### Optional componentClass: any

  - ##### Optional noThrow: boolean

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

### data

data: Cell[][]

- Defined in ui/Matrix/Matrix.ts :300

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

### selectedColumnValue

selectedColumnValue: any

- Defined in ui/Matrix/Matrix.ts :313

### selectedRowValue

selectedRowValue: string

- Defined in ui/Matrix/Matrix.ts :308

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

## Accessors

### usageAnalytics

usageAnalytics:

Inherited from Component.usageAnalytics

- Defined in ui/Base/Component.ts :343

## Component Options

### cellFontSize

cellFontSize: string

- Defined in ui/Matrix/Matrix.ts :208

Markup configuration example(s) :

    data-cell-font-size='foo'

### columnField

columnField: IFieldOption

- Defined in ui/Matrix/Matrix.ts :97

Markup configuration example(s) :

    data-column-field='@foo'

### columnFieldValues

columnFieldValues: string[]

- Defined in ui/Matrix/Matrix.ts :130

### columnHeader

columnHeader: string

- Defined in ui/Matrix/Matrix.ts :144

Markup configuration example(s) :

    data-column-header='foo'

### columnLabels

columnLabels: string[]

- Defined in ui/Matrix/Matrix.ts :137

### computedField

computedField: IFieldOption

- Defined in ui/Matrix/Matrix.ts :168

Markup configuration example(s) :

    data-computed-field='@foo'

### computedFieldFormat

computedFieldFormat: string

- Defined in ui/Matrix/Matrix.ts :196

Markup configuration example(s) :

    data-computed-field-format='foo'

### computedFieldOperation

computedFieldOperation: string

- Defined in ui/Matrix/Matrix.ts :181

Markup configuration example(s) :

    data-computed-field-operation='foo'

### enableColumnTotals

enableColumnTotals: boolean

- Defined in ui/Matrix/Matrix.ts :161

Markup configuration example(s) :

    data-enable-column-totals='true'
    data-enable-column-totals='false'

### enableHoverPreview

enableHoverPreview: boolean

- Defined in ui/Matrix/Matrix.ts :219

Markup configuration example(s) :

    data-enable-hover-preview='true'
    data-enable-hover-preview='false'

### enableRowTotals

enableRowTotals: boolean

- Defined in ui/Matrix/Matrix.ts :120

Markup configuration example(s) :

    data-enable-row-totals='true'
    data-enable-row-totals='false'

### maximumNumberOfRows

maximumNumberOfRows: number

- Defined in ui/Matrix/Matrix.ts :113

Markup configuration example(s) :

    data-maximum-number-of-rows='10'

### maximumNumberOfValuesInGroupBy

maximumNumberOfValuesInGroupBy: number

- Defined in ui/Matrix/Matrix.ts :154

Markup configuration example(s) :

    data-maximum-number-of-values-in-group-by='10'

### previewDelay

previewDelay: number

- Defined in ui/Matrix/Matrix.ts :273

Markup configuration example(s) :

    data-preview-delay='10'

### previewMaxWidth

previewMaxWidth: string

- Defined in ui/Matrix/Matrix.ts :257

Markup configuration example(s) :

    data-preview-max-width='foo'

### previewMinWidth

previewMinWidth: string

- Defined in ui/Matrix/Matrix.ts :265

Markup configuration example(s) :

    data-preview-min-width='foo'

### previewSortCriteria

previewSortCriteria: string

- Defined in ui/Matrix/Matrix.ts :241

Markup configuration example(s) :

    data-preview-sort-criteria='foo'

### previewSortField

previewSortField: IFieldOption

- Defined in ui/Matrix/Matrix.ts :249

Markup configuration example(s) :

    data-preview-sort-field='@foo'

### previewTemplate

previewTemplate: Template

- Defined in ui/Matrix/Matrix.ts :294

### rowField

rowField: IFieldOption

- Defined in ui/Matrix/Matrix.ts :90

Markup configuration example(s) :

    data-row-field='@foo'

### sortCriteria

sortCriteria: string

- Defined in ui/Matrix/Matrix.ts :106

Markup configuration example(s) :

    data-sort-criteria='foo'

### title

title: string

- Defined in ui/Matrix/Matrix.ts :83

Markup configuration example(s) :

    data-title='foo'

## Constructors

### constructor

- new Matrix(element: HTMLElement, options?: IMatrixOptions, bindings?: IComponentBindings): Matrix

- Overwrites Component.constructor

  - Defined in ui/Matrix/Matrix.ts :317

  #### Parameters

  - ##### element: HTMLElement

  - ##### Optional options: IMatrixOptions

  - ##### Optional bindings: IComponentBindings

  #### Returns Matrix